/*

  DBSE 3
  (c) 2000-2003 Andrea Rizzi
  License: GPLv2 

*/
#ifndef DATABASE_2_H
#define DATABASE_2_H

#include <qstring.h>
#include <qvaluelist.h>
#include <db3/db_cxx.h>
#include <qobject.h>
#include <qregexp.h>

#include "dbentries.h"



class DataBase : public Db
{
 public:
    DataBase(QString dbpath, QString dbname, QString dblang);
    
 int open(DBTYPE type,unsigned int flags=0);

//Standard access (overload std functions)
    int get(Dbt * key,Dbt *data){return Db::get(0,key,data,0);}
	int put(Dbt * key,Dbt *data,int fl=0){return Db::put(0,key,data,0);}
  
//Overload, using this you loose the Key!!
	  
	int get(int i,DBItem *data){DBItemNum n(i);  return get(&n,data);}
    int put(int i,DBItem *data){DBItemNum n(i);  return put(&n,data);}
	
	unsigned int getLast();
	    
//For scrolling
   // int getFirst(DBItem *key,DBItem *data,QString table);
   // int getNext(DBItem *key,DBItem *data,QString table);
   // bool isEnd(QString table);
private:
    QString filename;
	QString database;
  DBTYPE mytype;  
};





class QueryResult  //from DBInterface to KDBSearchEngine
{
public:
  QueryResult();
  QueryResult(QString r);
  QueryResult(QString r,QString o,int s);
  void setRichResult(QString r) { richr=r;  }
  void setRichOriginal(QString r) { richo=r;  }
  
  QString richResult() {return richr;}
  QString richOriginal() {return richo;}
  
  QString result(){ return res; }
  QString original() {return orig; }
  int score() {return sco;}
//info contains originalkey,catalog,date,author etc...
  ResultInfo info(){ResultInfo i; i.info="no info"; return i;}


private:
   QString res;
   QString orig;
   QString richr;
   QString richo;
   int sco;

};

class InfoFilter
{
  int filter; //placeholder
};


class DataBaseInterface : public QObject
{

Q_OBJECT
 public:
    DataBaseInterface();  //Read settings from config files
    ~DataBaseInterface();
//You can ask me different thing:
  
    typedef QValueList<QueryResult> ResultList; 


    void stop(bool b=true) {stopNow=b;}


    //Search in main database exact strings
    ResultList exactMatch(QString query,InfoFilter *filter=0);
    
    //Search only the alphanumeric part of a string
    ResultList alphaMatch(QString query,InfoFilter *filter=0);
    
    //Search words
    ResultList wordsMatch(QString query,InfoFilter *filter=0);

    //Search in the single sentence fuzzy archive
    ResultList sentenceMatch(QString query,InfoFilter *filter=0);

    
	//addEntry and sync all the tables
	//if clean is true remove old translation of this string with same info ref
	
    bool addEntry(QString original,QString translated,InputInfo *info,bool clean=true);
	
	//change this
    

    QMap<QString,unsigned int> correlation(QString word,InfoFilter *filter=0);
    
 signals:
  void  newResult(QueryResult); 
 
 public:
 bool mainOk() {return  main!=0;} 
 bool catalogOk() {return  catalog!=0;} 
 bool alphaOk() {return  alpha!=0;} 
 bool sentenceOk() {return  sentence!=0;}
 bool numindexOk() {return  numindex!=0;} 
 bool wordsindexOk() {return  wordsindex!=0;} 
 bool externalOk() {return  external!=0;}
 bool wordOk() {return  word!=0;}
   
       
private:

    //Search in main database exact strings
  
  typedef QPair<DBItemMainKey,DBItemMainData> MainEntry;

  MainEntry get(QString query,InfoFilter *filter=0);
  
  DataBase * openMyDataBase(QString prefix,
                     QString name,QString l,DBTYPE tt);
  
  DataBase *main;
  DataBase *numindex;
  DataBase *wordsindex;
  DataBase *catalog;
  DataBase *alpha;
  DataBase *sentence;
  DataBase *word;
  DataBase *external; 
  
  bool stopNow;
  
 };
 
 int alphaKey(Db *, const Dbt *k, const Dbt *d, Dbt *nk);

//I'll define an object for them

QStringList words(QString s);
QStringList sentences(QString s);
QString simple(QString str,bool ck=false);
bool isUpper(QChar s);
bool isLower(QChar s);
QString format( QString _s,QString t);

#endif
 
